package org.aleabodo.fireworksmc;

import net.kyori.adventure.text.Component;
import net.kyori.adventure.text.format.NamedTextColor;
import net.kyori.adventure.text.format.TextColor;
import net.kyori.adventure.text.format.TextDecoration;
import org.bukkit.Bukkit;
import org.bukkit.entity.Player;
import org.bukkit.map.MinecraftFont;
import org.jetbrains.annotations.NotNull;

import java.util.Collection;

public class Message {

    public static void sendInfo(@NotNull Player player, Component ... content) {
        Component textComponent = Component.text().color(NamedTextColor.WHITE).build()
                .append(Component.text("[Fireworks] ")
                        .color(TextColor.color(0,213,255))
                        .decoration(TextDecoration.BOLD, true));
        for (Component comp : content) {
            textComponent = textComponent.append(comp);
        }

        player.sendMessage(textComponent);
    }

    public static void sendInfo(@NotNull Player player, String content) {
        sendInfo(player, Component.text(content));
    }

    public static void sendInfo(Collection<Player> players, Component ... content) {
        for (Player p : players) {
            sendInfo(p, content);
        }
    }

    public static void sendInfo(Collection<Player> players, String content) {
        for (Player p : players) {
            sendInfo(p, content);
        }
    }

    /*
     * #############################################################################
     * Warning
     */

    public static void sendWarning(@NotNull Player player, Component ... content) {
        Component textComponent = Component.text().color(NamedTextColor.WHITE).build()
                .append(Component.text("[Fireworks] ")
                        .color(TextColor.color(255, 3, 4))
                        .decoration(TextDecoration.BOLD, true));

        for (Component comp : content) {
            textComponent = textComponent.append(comp);
        }

        player.sendMessage(textComponent);
    }

    public static void sendWarning(@NotNull Player player, String content) {
        sendWarning(player, Component.text(content));
    }

    public static void sendWarning(Collection<Player> players, Component ... content) {
        for (Player p : players) {
            sendWarning(p, content);
        }
    }

    public static void sendWarning(Collection<Player> players, String content) {
        for (Player p : players) {
            sendWarning(p, content);
        }
    }

    /*
     * #############################################################################
     * Broadcast
     */

    public static void sendBroadcast(Component ... content) {
        Component textComponent = Component.text().color(NamedTextColor.WHITE).build()
                .append(Component.text("[Fireworks] ")
                        .color(TextColor.color(255, 153, 0))
                        .decoration(TextDecoration.BOLD, true));

        for (Component comp : content) {
            textComponent = textComponent.append(comp);
        }

        for (Player p : Bukkit.getOnlinePlayers()) {
            p.sendMessage(textComponent);
        }
    }

    public static void sendBroadcast(String content) {
        sendBroadcast(Component.text(content));
    }

    /*
     * #############################################################################
     * Debug
     */

    public static void sendDebug(Component ... content) {
        Component textComponent = Component.text().color(NamedTextColor.WHITE).build()
                .append(Component.text("[Fireworks] ")
                        .color(TextColor.color(255, 0, 245))
                        .decoration(TextDecoration.BOLD, true));

        for (Component comp : content) {
            textComponent = textComponent.append(comp);
        }

        for (Player p : Bukkit.getOnlinePlayers()) {
            if (p.hasPermission("fireworksmc.debug"))
                p.sendMessage(textComponent);
        }
    }

    public static void sendDebug(String content) {
        sendDebug(Component.text(content));
    }

    /*
     * #############################################################################
     * Utils
     */

    public static int getNumberOfDotsToAlign(String displayText) {
        return (int) Math.round((130.0 - MinecraftFont.Font.getWidth(displayText))/2);
    }
}