package org.aleabodo.fireworksmc;

import org.bukkit.Color;
import org.bukkit.FireworkEffect;
import org.bukkit.Location;
import org.bukkit.entity.EntityType;
import org.bukkit.entity.Firework;
import org.bukkit.inventory.meta.FireworkMeta;
import org.bukkit.scheduler.BukkitRunnable;

import java.security.MessageDigest;
import java.security.NoSuchAlgorithmException;
import java.util.Random;

public class Show {
    private long seed;
    private Location location;
    private Direction direction;
    private int duration; //in seconds
    private int bpm;

    public Show(long seed, Location location, Direction direction, int duration, int bpm) {
        this.seed = seed;
        this.location = location;
        this.direction = direction;
        this.duration = duration;
        this.bpm = bpm;
    }

    /*
     * Generate the firework show according to the random seed and the timings/highlights configured
     */
    public void generate() {

    }

    /**
     * Executes the firework show
     */
    public void start() {
        spawnRocket(this.location);
    }

    public void spawnRocket(Location location) {
        Firework firework = (Firework) location.getWorld().spawnEntity(location, EntityType.FIREWORK);
        FireworkMeta fireworkMeta = firework.getFireworkMeta();

        // Create a firework effect
        FireworkEffect effect = FireworkEffect.builder()
                .flicker(true)
                .trail(true)
                .withColor(Color.RED)
                .withFade(Color.YELLOW)
                .with(FireworkEffect.Type.BALL_LARGE)
                .build();

        fireworkMeta.addEffect(effect);
        fireworkMeta.setPower(1); // Number of times the firework will explode
        firework.setFireworkMeta(fireworkMeta);

        // Schedule the firework to be removed after a delay
        new BukkitRunnable() {
            @Override
            public void run() {
                firework.detonate();
            }
        }.runTaskLater(Fireworks_Mc.getPlugin(), 20); // 20 ticks = 1 second
    }

    /*
     * ################### GETTER ###################
     */

    public long getSeed() {
        return seed;
    }

    public Location getLocation() {
        return location;
    }

    public Direction getDirection() {
        return direction;
    }

    public int getDuration() {
        return duration;
    }

    public int getBpm() {
        return bpm;
    }

    /*
     * ################### SETTER ###################
     */

    public void setSeed(long seed) {
        this.seed = seed;
    }

    public void setLocation(Location location) {
        this.location = location;
    }

    public void setDirection(Direction direction) {
        this.direction = direction;
    }

    public void setDuration(int duration) {
        this.duration = duration;
    }

    public void setBpm(int bpm) {
        this.bpm = bpm;
    }
}
