package org.aleabodo.fireworksmc;

import java.security.MessageDigest;
import java.security.NoSuchAlgorithmException;
import java.util.Random;

public class Utils {
    /**
     *
     * @param seed as long
     * @return Random number between 0 and based on the seed
     */
    public static double generateRandomValueFromSeed(long seed) {
        return new Random(seed).nextDouble();
    }

    /**
     *
     * @param seedString Random seed as string
     * @return Seed converted as long
     */
    public static long generateLongFromSeed(String seedString) {
        try {
            MessageDigest md = MessageDigest.getInstance("SHA-256");
            byte[] hashBytes = md.digest(seedString.getBytes());

            // Convert the first 8 bytes of the hash to a long value
            long hashValue = 0;
            for (int i = 0; i < 8; i++) {
                hashValue = (hashValue << 8) | (hashBytes[i]);
            }

            return hashValue;
        } catch (NoSuchAlgorithmException e) {
            throw new RuntimeException("Hashing algorithm not available. (Have to check or Intellij complains.", e);
        }
    }
}
